=== debian/changelog ===
libdigidocpp (0.3.0-0ubuntu11) xenial; urgency=medium

  * PHP bindings are not packaged, so there is no build-dependency (LP:
    #1566394).

 -- Nishanth Aravamudan <nish.aravamudan@canonical.com>  Tue, 05 Apr 2016 08:30:27 -0700

libdigidocpp (0.3.0-0ubuntu10) xenial; urgency=medium

  * Drop python-support build-depends, python bindings are not built.
  * Comment out comparison with CONTENT_HASHCODE, which is not defined
    anywhere at all...

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 23 Feb 2016 14:03:47 +0000

libdigidocpp (0.3.0-0ubuntu9) wily; urgency=medium

  * No-change rebuild against libxml-security-c17v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 10 Aug 2015 23:34:28 +0000

libdigidocpp (0.3.0-0ubuntu8) vivid; urgency=medium

  * Replace NBS zlib-bin build dep with minizip.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 02 Feb 2015 15:19:35 +0100

libdigidocpp (0.3.0-0ubuntu7) saucy; urgency=low

  * Rebuild for libxml-security-c17.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 16 Jul 2013 18:14:46 +0100

libdigidocpp (0.3.0-0ubuntu6) quantal; urgency=low

  * 0002_missing_include.patch:
    + Added new patch from upstream SVN to add missing G++ 4.7 include.

 -- Martin-Éric Racine <q-funk@ubuntu.com>  Mon, 30 Apr 2012 17:36:14 +0300

libdigidocpp (0.3.0-0ubuntu5) quantal; urgency=low

  * Build-Depends: added zlib-bin for MiniZip.
  * Bumped Standards-Version to 3.9.3 (no change required).

 -- Martin-Éric Racine <q-funk@ubuntu.com>  Fri, 27 Apr 2012 12:26:36 +0300

libdigidocpp (0.3.0-0ubuntu4) precise; urgency=low

  * 0001_new_EstEID_root_CA.patch:
    + Add the latest EstEID root CA issued by Sertifitseerimiskeskus.

 -- Martin-Éric Racine <q-funk@ubuntu.com>  Wed, 07 Mar 2012 03:08:59 +0200

libdigidocpp (0.3.0-0ubuntu3) precise; urgency=high

  * Urgency=high; this library is stalling 3 other packages in dep-wait.
  * Reintroduce CDBS list-missing only for common-binary-post-install-arch.

 -- Martin-Éric Racine <q-funk@ubuntu.com>  Fri, 27 Jan 2012 17:48:56 +0200

libdigidocpp (0.3.0-0ubuntu2) precise; urgency=low

  * Replace CDBS utils.mk list-missing with dh_install --list-missing.
    - Removed: include /usr/share/cdbs/1/rules/utils.mk,
      common-binary-post-install-arch common-binary-post-install-indep::
    + Added: DEB_DH_INSTALL_ARGS += --list-missing

 -- Martin-Éric Racine <q-funk@ubuntu.com>  Thu, 26 Jan 2012 22:12:19 +0200

libdigidocpp (0.3.0-0ubuntu1) precise; urgency=low

  * Initial release for Ubuntu (LP: #916434).
    Based upon initial packaging by Kalev Lember, with further improvements
    by Guido Tabbernuk, then packaging review by Martin-Éric Racine.
  * Perl/PHP/Python bindings are not packaged for this version. Upstream
    doesn't consider them as ready for public consumption just yet.

 -- Martin-Éric Racine <q-funk@ubuntu.com>  Sat, 14 Jan 2012 02:47:58 +0200
