=== debian/control ===
Source: libdigidocpp
Section: libs
Priority: optional
Homepage: http://code.google.com/p/esteid/
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Guido Tabbernuk <boamaod@gmail.com>, Martin-Éric Racine <martin-eric.racine@iki.fi>
Build-Depends: cdbs, debhelper (>= 7), cmake, pkg-config, 
 libdigidoc-dev, libp11-dev, libperl-dev, libpkcs11-helper-dev, 
 libssl-dev, libxml-security-c-dev,
 swig, xsdcxx, minizip
Standards-Version: 3.9.3

Package: libdigidocpp-common
Architecture: all
Section: misc
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: libdigidocpp architecture-independent files
 BDoc C++ lib is library for creating and validating BDOC-1.0 documents.
 Older Digidoc formats (DIGIDOC-XML) are not supported.
 .
 This package provides the architecture-independent files.

Package: libdigidocpp-dev
Section: libdevel
Architecture: any
Breaks: libdigidoc0-dev (<< 0.1.0), libdigidoc++0-dev (<< 0.1.0)
Replaces: libdigidoc0-dev (<< 0.1.0), libdigidoc++0-dev (<< 0.1.0)
Depends: libdigidocpp0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
 libdigidoc-dev, libp11-dev, libssl-dev, libxml-security-c-dev, xsdcxx 
Description: libdigidocpp development files
 BDoc C++ lib is library for creating and validating BDOC-1.0 documents.
 Older Digidoc formats (DIGIDOC-XML) are not supported.
 .
 This package provides the development files.

#Package: perl-digidoc
#Section: perl
#Architecture: any
#Depends: libdigidocpp0 (= ${binary:Version}), ${perl:Depends}, ${misc:Depends}, ${shlibs:Depends}
#Description: libdigidocpp Perl bindings
# BDoc C++ lib is library for creating and validating BDOC-1.0 documents.
# Older Digidoc formats (DIGIDOC-XML) are not supported.
# .
# This package provides the Perl bindings.

#Package: php-digidoc
#Section: php
#Architecture: any
#Depends: libdigidocpp0 (= ${binary:Version}), ${php:Depends}, ${misc:Depends}, ${shlibs:Depends}
#Description: libdigidocpp PHP bindings
# BDoc C++ lib is library for creating and validating BDOC-1.0 documents.
# Older Digidoc formats (DIGIDOC-XML) are not supported.
# .
# This package provides the PHP bindings.

#Package: python-digidoc
#Section: python
#Architecture: any
#Depends: libdigidocpp0 (= ${binary:Version}), ${python:Depends}, ${misc:Depends}, ${shlibs:Depends}
#Description: libdigidocpp Python bindings
# BDoc C++ lib is library for creating and validating BDOC-1.0 documents.
# Older Digidoc formats (DIGIDOC-XML) are not supported.
# .
# This package provides the Python bindings.

Package: libdigidocpp0-dbg
Architecture: any
Section: debug
Priority: extra
Breaks: libdigidoc0-dbg (<< 0.1.0), libdigidoc++0-dbg (<< 0.1.0)
Replaces: libdigidoc0-dbg (<< 0.1.0), libdigidoc++0-dbg (<< 0.1.0)
Depends: libdigidocpp0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: libdigidocpp debugging symbols
 BDoc C++ lib is library for creating and validating BDOC-1.0 documents.
 Older Digidoc formats (DIGIDOC-XML) are not supported.
 .
 This package provides the debugging symbols.
 
Package: libdigidocpp0
Architecture: any
Provides: libdigidoc0, libdigidoc++0
Breaks: libdigidoc0 (<< 0.1.0), libdigidoc++0 (<< 0.1.0)
Replaces: libdigidoc0 (<< 0.1.0), libdigidoc++0 (<< 0.1.0)
Depends: libdigidocpp-common, opensc, ${misc:Depends}, ${shlibs:Depends}
Description: BDoc C++ library for processing digital signatures
 BDoc C++ lib is library for creating and validating BDOC-1.0 documents.
 Older Digidoc formats (DIGIDOC-XML) are not supported. Difference between
 DDoc, EDoc and BDoc are described in. BDoc signatures should be XAdES
 compliant, but some XAdES signatures may be uncompliant with BDoc. Currently
 BDoc-1.0 BES and TM profiles are supported.
 .
 Signatures can be given using EstEID Card (id-kaart) and RSA certificates
 with private keys.
 .
 This package provides the runtime libraries.
