=== debian/rules ===
#!/usr/bin/make -f
# [debian/rules] for libdigidocpp
#
# COPYRIGHT
# © 2012 Martin-Éric Racine <martin-eric.racine@iki.fi>
# © 2012 Guido Tabbernuk <boamaod@gmail.com>
#
# LICENSE
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_CMAKE_EXTRA_FLAGS += -DSYSCONF_INSTALL_DIR=/etc

#install/php-digidoc::
#	echo "php:Depends=phpapi-$(shell php-config5 --phpapi)" >> debian/php-digidoc.substvars

#install/python-digidoc::
#	find debian/tmp/ -name "*.pyc" -depth -exec rm -rf {} \;

common-binary-post-install-arch:: list-missing

#EOF
